CREATE PROCEDURE STGTRSODS.P_LOAD_DC_UNIVL_PLAN_R2_R3 
( IN in_cycle_id CHAR(2))
    RESULT SETS 1
    LANGUAGE SQL
    
P1: BEGIN
------------------------------------------------------------------------
-- DECLARE SECTION
------------------------------------------------------------------------
DECLARE SQLSTATE CHAR(5);
DECLARE wk_sqlstate             CHAR(5) DEFAULT '00000';
DECLARE cs_VALUE            CHARACTER(100);
DECLARE wk_fetch_status          CHAR(5) DEFAULT '00000';
DECLARE cs_PLAN_NUM             CHARACTER(6);
DECLARE cs_SUB_PLAN             CHARACTER(6);

--CLARE cs_if_cursor CURSOR WITH HOLD WITH RETURN FOR cs_if_cursor;

SET  wk_stg_cfe_r3 = ACCTLOAD.F_GET_ETL_TABLE(in_cycle_id,'ACCTLOAD.T_STG_CFE_$$$_R3');
SET  wk_stg_cfe_r2 = ACCTLOAD.F_GET_ETL_TABLE(in_cycle_id,'ACCTLOAD.T_STG_CFE_$$$_R2');


FETCH cs_if_cursor
    INTO cs_PLAN_NUM, cs_SUB_PLAN, cs_KEY_WORD, cs_VALUE;

WHILE (wk_fetch_status = '00000') DO
    CASE cs_KEY_WORD
        WHEN 'DSHR PARTICIPATING DATASHARE INDICATOR' THEN
            IF EXISTS(SELECT 1 FROM SESSION.GLBLTMP_R3_R2 WHERE PLAN_NUM = cs_PLAN_NUM AND SUB_PLAN = cs_SUB_PLAN) THEN
                UPDATE SESSION.GLBLTMP_R3_R2
                    SET DSHR_PARTICIPATING_IND = SUBSTR(cs_VALUE,1,1)
                 WHERE PLAN_NUM = cs_PLAN_NUM
                   AND SUB_PLAN = cs_SUB_PLAN;
            ELSE
                INSERT INTO SESSION.GLBLTMP_R3_R2 (PLAN_NUM,SUB_PLAN, DSHR_PARTICIPATING_IND, DSHR_FUNCTION)
                VALUES (cs_PLAN_NUM,cs_SUB_PLAN, SUBSTR(cs_VALUE,1,1), NULL);
            END IF;
            
        WHEN 'DSHR DATASHARE FUNCTION' THEN
            IF EXISTS(SELECT 1 FROM SESSION.GLBLTMP_R3_R2 WHERE PLAN_NUM = cs_PLAN_NUM AND SUB_PLAN = cs_SUB_PLAN) THEN
                UPDATE SESSION.GLBLTMP_R3_R2
                    SET DSHR_FUNCTION = SUBSTR(cs_VALUE,1,1)
                 WHERE PLAN_NUM = cs_PLAN_NUM
                   AND SUB_PLAN = cs_SUB_PLAN;
            ELSE
                INSERT INTO SESSION.GLBLTMP_R3_R2 (PLAN_NUM,SUB_PLAN, DSHR_PARTICIPATING_IND, DSHR_FUNCTION)
                VALUES (cs_PLAN_NUM,cs_SUB_PLAN, NULL, SUBSTR(cs_VALUE,1,1));
            END IF;
             
    END CASE;
END WHILE;

END P1